// SccTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	HMODULE hSccLibrary = ::LoadLibrary( "C:\\Program Files\\SourceGear\\Vault Client\\VS2003_Client\\VaultIDE.dll" );
	if( hSccLibrary )
	{
		funcSccInitialize pSccInitialize = (funcSccInitialize)GetProcAddress( hSccLibrary, _T("SccInitialize") );
		if( pSccInitialize )
		{
			LPVOID pSccLibraryContext = NULL;

			TCHAR szSccName[ SCC_NAME_SIZE ];
			TCHAR szAuxPathLabel[ SCC_AUXLABEL_SIZE ];
			LONG lSccCaps = 0;
			LONG lCheckoutCommentLen = 0;
			LONG lCommentLen = 0;
			long lResult = pSccInitialize( &pSccLibraryContext,		// __deref_out LPVOID * ppContext,
				GetDesktopWindow(),													// __in HWND hWnd,
				_T("TestApp"),														// __in_z LPCSTR lpCallerName,
				szSccName,																	// __out_z __out_ecount(SCC_NAME_SIZE) LPSTR lpSccName,
				&lSccCaps,																	// __out LPLONG lpSccCaps,
				szAuxPathLabel,															// __out_z __out_ecount(SCC_AUXLABEL_SIZE) LPSTR lpAuxPathLabel,
				&lCheckoutCommentLen,												// __out LPLONG pnCheckoutCommentLen,
				&lCommentLen																// __out LPLONG pnCommentLen
				);
			if( lResult != SCC_OK )
			{
				MessageBox( GetDesktopWindow(), "Unable to initialise Source Control", "Error Initialising", MB_OK | MB_ICONERROR );
			}
			else
			{
				// Set up the SCC function pointers
				funcSccGetProjPath pSccGetProjPath = (funcSccGetProjPath)GetProcAddress( hSccLibrary, _T("SccGetProjPath") );
				funcSccOpenProject pSccOpenProject = (funcSccOpenProject)GetProcAddress( hSccLibrary, _T("SccOpenProject") );



				TCHAR szUserName[ SCC_USER_SIZE ];
				strcpy( szUserName, "danp" );

				TCHAR szProjName[ SCC_PRJPATH_SIZE ];
				strcpy( szProjName, "$/web sites/site stats" );

				TCHAR szLocalProjPath[ _MAX_PATH ];
				strcpy( szLocalProjPath, "c:\\projectsGM\\web sites\\site stats" );

				TCHAR szAuxProjPath[ SCC_PRJPATH_SIZE ];
				szAuxProjPath[0] = _T('\0');


				BOOL bCreateNewProject = FALSE;
				if( pSccLibraryContext && pSccGetProjPath )
				{
					try
					{
						LONG lr = pSccGetProjPath(
							pSccLibraryContext,													// __inout LPVOID pContext,
							GetDesktopWindow(),													// __in HWND hWnd,
							szUserName,																	// __inout_z __inout_ecount(SCC_USER_SIZE) LPSTR lpUser,
							szProjName,																	// __inout_z __inout_ecount(SCC_PRJPATH_SIZE) LPSTR lpProjName,
							szLocalProjPath,														// __inout_z __inout_ecount(_MAX_PATH) LPSTR lpLocalPath,
							szAuxProjPath,															// __inout_z __inout_ecount(SCC_PRJPATH_SIZE) LPSTR lpAuxProjPath,
							FALSE,																			// __in BOOL bAllowChangePath,
							&bCreateNewProject													// __inout LPBOOL pbNew
							);
						if( lr != SCC_OK )
						{
							if( lr != SCC_I_OPERATIONCANCELED )
							{
								MessageBox( GetDesktopWindow(), "Oh Oh error", "Error", MB_OK | MB_ICONERROR );
							}

							return EXIT_FAILURE;
						}
						else
						{
							MessageBox( GetDesktopWindow(), szAuxProjPath, "Hurrah", MB_OK | MB_ICONERROR );

							return EXIT_SUCCESS;
						}
					}
					catch( ... )
					{
						MessageBox( GetDesktopWindow(), "Oh Oh exception", "Error", MB_OK | MB_ICONERROR );
						return EXIT_FAILURE;
					}	
				}


			}
		}
	}


	return 0;
}

