// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#include "targetver.h"

#include <windows.h>
#include <stdio.h>
#include <tchar.h>



// TODO: reference additional headers your program requires here
#if _MSC_VER < 1500
#define __inout_opt
#define __in
#define __inout
#define __in_z
#define __inout_z
#define __in_opt
#define __deref_out
#define __deref_opt_out_opt
#define __out
#define __out_z
#define __in_ecount( sz )
#define __out_ecount( sz )
#define __inout_ecount( sz )
#endif
#include "scc.h"


typedef SCCRTN (*funcSccInitialize)( __deref_out LPVOID * ppContext, 
																		__in HWND hWnd, 
																		__in_z LPCSTR lpCallerName,
																		__out_z __out_ecount(SCC_NAME_SIZE) LPSTR lpSccName, 
																		__out LPLONG lpSccCaps, 
																		__out_z __out_ecount(SCC_AUXLABEL_SIZE) LPSTR lpAuxPathLabel, 
																		__out LPLONG pnCheckoutCommentLen, 
																		__out LPLONG pnCommentLen );

typedef SCCRTN (*funcSccUninitialize)( __inout LPVOID pContext );


typedef SCCRTN (*funcSccGetProjPath)(
																		 __inout LPVOID pContext, 
																		 __in HWND hWnd, 
																		 __inout_z __inout_ecount(SCC_USER_SIZE) LPSTR lpUser,
																		 __inout_z __inout_ecount(SCC_PRJPATH_SIZE) LPSTR lpProjName, 
																		 __inout_z __inout_ecount(_MAX_PATH) LPSTR lpLocalPath,
																		 __inout_z __inout_ecount(SCC_PRJPATH_SIZE) LPSTR lpAuxProjPath,
																		 __in BOOL bAllowChangePath,
																		 __inout LPBOOL pbNew
																		 );

typedef SCCRTN (*funcSccOpenProject)(
																		 __inout LPVOID pContext,
																		 __in HWND hWnd, 
																		 __inout_z __inout_ecount(SCC_USER_SIZE) LPSTR lpUser,
																		 __inout_z __inout_ecount(SCC_PRJPATH_SIZE) LPSTR lpProjName,
																		 __in_z LPCSTR lpLocalProjPath,
																		 __inout_z __inout_ecount(SCC_PRJPATH_SIZE) LPSTR lpAuxProjPath,
																		 __in_z __in_opt LPCSTR lpComment,
																		 __in_opt LPTEXTOUTPROC lpTextOutProc,
																		 __in LONG dwFlags
																		 );

typedef SCCRTN (*funcSccCloseProject)(
																			__inout LPVOID pContext
																			);



typedef SCCRTN (*funcSccGet)(
														 __inout LPVOID pContext, 
														 __in HWND hWnd, 
														 __in LONG nFiles, 
														 __in_ecount(nFiles) LPCSTR* lpFileNames, 
														 __in LONG dwFlags,
														 __in_opt LPCMDOPTS pvOptions
														 );

typedef SCCRTN (*funcSccBackgroundGet)(
																			 __inout LPVOID pContext, 
																			 __in LONG nFiles, 
																			 __in_ecount(nFiles) LPCSTR* lpFileNames, 
																			 __in LONG dwFlags,
																			 __in LONG dwBackgroundOperationID
																			 );

typedef SCCRTN (*funcSccQueryInfo)(
																	 __inout LPVOID pContext, 
																	 __in LONG nFiles, 
																	 __in_ecount(nFiles) LPCSTR* lpFileNames, 
																	 __out_ecount(nFiles) LPLONG lpStatus
																	 );

typedef SCCRTN (*funcSccAdd)(
														 __inout LPVOID pContext, 
														 __in HWND hWnd, 
														 __in LONG nFiles, 
														 __in_ecount(nFiles) LPCSTR* lpFileNames, 
														 __in_z __in_opt LPCSTR lpComment, 
														 __in_ecount(nFiles) LONG * pdwFlags,
														 __in_opt LPCMDOPTS pvOptions
														 );

typedef SCCRTN (*funcSccRemove)(
																__inout LPVOID pContext, 
																__in HWND hWnd, 
																__in LONG nFiles, 
																__in_ecount(nFiles) LPCSTR* lpFileNames,
																__in_z __in_opt LPCSTR lpComment,
																__in LONG dwFlags,
																__in_opt LPCMDOPTS pvOptions
																);

typedef SCCRTN (*funcSccCheckout)(
																	__inout LPVOID pContext, 
																	__in HWND hWnd, 
																	__in LONG nFiles, 
																	__in_ecount(nFiles) LPCSTR* lpFileNames, 
																	__in_z __in_opt LPCSTR lpComment, 
																	__in LONG dwFlags,
																	__in_opt LPCMDOPTS pvOptions
																	);

typedef SCCRTN (*funcSccCheckin)(
																 __inout LPVOID pContext, 
																 __in HWND hWnd, 
																 __in LONG nFiles, 
																 __in_ecount(nFiles) LPCSTR* lpFileNames, 
																 __in_z __in_opt LPCSTR lpComment, 
																 __in LONG dwFlags,
																 __in_opt LPCMDOPTS pvOptions
																 );

typedef SCCRTN (*funcSccUncheckout)(
																		__inout LPVOID pContext, 
																		__in HWND hWnd, 
																		__in LONG nFiles, 
																		__in_ecount(nFiles) LPCSTR* lpFileNames, 
																		__in LONG dwFlags,
																		__in_opt LPCMDOPTS pvOptions
																		);

typedef SCCRTN (*funcSccDiff)(
															__inout LPVOID pContext, 
															__in HWND hWnd, 
															__in_z LPCSTR lpFileName, 
															__in LONG dwFlags,
															__in_opt LPCMDOPTS pvOptions
															);

typedef SCCRTN (*funcSccRename)(
																__inout LPVOID pContext, 
																__in HWND hWnd, 
																__in_z LPCSTR lpFileName,
																__in_z LPCSTR lpNewName
																);

typedef SCCRTN (*funcSccHistory)(
																 __inout LPVOID pContext, 
																 __in HWND hWnd, 
																 __in LONG nFiles, 
																 __in_ecount(nFiles) LPCSTR* lpFileNames, 
																 __in LONG dwFlags,
																 __in_opt LPCMDOPTS pvOptions
																 );

typedef SCCRTN (*funcSccProperties)(
																		__inout LPVOID pContext, 
																		__in HWND hWnd, 
																		__in_z LPCSTR lpFileName
																		);

typedef SCCRTN (*funcSccEnumChangedFiles)(
	__inout LPVOID pContext,									  
	__in HWND hWnd, 
	__in LONG cFiles, 
	__in_ecount(cFiles) LPCSTR* lpFileNames, 
	__out_ecount(cFiles) LONG* plIsFileDifferent
	);

typedef SCCRTN (*funcSccGetCommandOptions)(
	__inout LPVOID pContext, 
	__in HWND hWnd, 
	__in enum SCCCOMMAND nCommand,
	__deref_opt_out_opt LPCMDOPTS * ppvOptions
	);

typedef SCCRTN (*funcSccRunScc)(
																__inout LPVOID pContext, 
																__in HWND hWnd, 
																__in LONG nFiles, 
																__in_ecount(nFiles) LPCSTR* lpFileNames
																);

typedef SCCRTN (*funcSccGetExtendedCapabilities)(
	__inout LPVOID pContext, 
	__in LONG   lSccExCap,
	__out LPBOOL pbSupported
	);

